--[[

The MIT License Copyright (c) 2017 Paul "Myrroddin" Vandersypen Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

]]--

local addonName, addon = ...

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")

local raceInfoIDs = {
    ["Dwarf"] = 1,
    ["Draenei"] = 2,
    ["Fossil"] = 3,
    ["Night Elf"] = 4,
    ["Nerubian"] = 5,
    ["Orc"] = 6,
    ["Tol'vir"] = 7,
    ["Troll"] = 8,
    ["Vrykul"] = 27,
    ["Mantid"] = 29,
    ["Pandaren"] = 229,
    ["Mogu"] = 231,
    ["Arakkoa"] = 315,
    ["Draenor Clans"] = 350,
    ["Ogre"] = 382,
    ["Highborne"] = 404,
    ["Highmountain Tauren"] = 406,
    ["Demonic"] = 408,
}

function addon:GetData()
    local raceCount = GetNumArchaeologyRaces() + 1 -- purposely go out of bounds

    for i = 1, raceCount do
        local raceName, textureID, itemID, numFragsCol, numFragsReq, maxFrags = GetArchaeologyRaceInfo(i)
        local keystoneName = GetItemInfo(itemID)
        ARI73DB[raceName] = ARI73DB[raceName] or {}

        ARI73DB[raceName]["raceIndex"] = i
        ARI73DB[raceName]["textureID"] = textureID
        ARI73DB[raceName]["keystoneID"] = itemID
        ARI73DB[raceName]["keystoneName"] = keystoneName
        ARI73DB[raceName]["maxFragments"] = maxFrags
        ARI73DB[raceName]["collFrags"] = numFragsCol
        ARI73DB[raceName]["reqFrags"] = numFragsReq
    end

    for k, v in pairs(raceInfoIDs) do
        local raceName, textureID, raceItemID, numFragsCol, numFragsReq, maxFrags = GetArchaeologyRaceInfoByID(v)
        local value = tostring(v)
        ARI73DB[value] = ARI73DB[value] or {}
        ARI73DB[value]["raceName"] = raceName
        ARI73DB[value]["raceTexture"] = textureID
        ARI73DB[value]["raceItemID"] = raceItemID
        ARI73DB[value]["maxFragements"] = maxFrags
    end
end

function addon:PLAYER_LOGIN()
    ARI73DB = ARI73DB or {}
    addon:GetData()
end

f:SetScript("OnEvent", function(self, event, ...)
    addon[event](self, ...)
end)
